<template>
  <div>
    <b-row class="px-1 mb-05">
      <b-col cols="4" class="search-input-center search-bx d-flex justify-content-start">
        <div class="d-flex align-items-center">
          <label v-if="checkedCount != 0 && isSelect == false" class="numberof-data">{{ checkedCount }} Selected</label>
          <label v-if="checkedCount != 0 && isSelect == true" class="numberof-data">{{ allCount }} Selected</label>
          <b-button v-if="checkedCount != 0" @click="selectUnselectAll()" class="add-button mr-1 select-all-btn"
            variant="white">
            <span class="text-nowrap" v-if="isSelect == false">Select All {{ allCount }}</span>
            <span class="text-nowrap" v-if="isSelect == true">Unselect All {{ allCount }}</span>
          </b-button>
        </div>
      </b-col>
      <b-col cols="4" class="search-input-center search-bx d-flex justify-content-center">
        <div class="d-flex search-input-text index-search-form-group">
          <!--align-items-center justify-content-start-->
          <b-form-group>
            <div class="d-flex align-items-center">
              <!-- <label class="mr-1">Search</label> -->
              <IconSearchMute class="custom-search-icon" />
              <b-form-input v-model="searchQuery" placeholder="Search" type="text"
                class="d-inline-block custom-search-box index-search" />
            </div>
          </b-form-group>
        </div>
      </b-col>
      <b-col cols="4" class="search-input-center search-bx d-flex justify-content-end">
        <div class="d-flex align-items-center justify-content-end">
          <b-button @click="filterModalToggle()" class="add-button iconviewbutton" variant="white">
            <span class="text-nowrap label-hidden">Filters</span>
            <IconFilter></IconFilter>
          </b-button>
          <div class="action-btn-group ml-1" v-if="ability.can('read', 'roles_export')">
            <b-dropdown text="" variant="white" class="iconviewbutton" right>
              <template #button-content>
                <span class="text-nowrap label-hidden">Actions</span>
                <IconAction></IconAction>
              </template>
              <b-dropdown-item v-if="ability.can('read', 'roles_export')" @click="columnModalToggle()">
                Export
              </b-dropdown-item>
              <!-- <b-dropdown-item> Delete </b-dropdown-item>
                <b-dropdown-item @click="allStatusChange"> Hide </b-dropdown-item> -->
            </b-dropdown>
          </div>
          <b-button class="add-button iconviewbutton" variant="primary" v-if="ability.can('read', 'roles_add')"
            :to="{ name: 'role-create' }">
            <span class="text-nowrap label-hidden">Add New</span>
            <IconPlusActive></IconPlusActive>
          </b-button>
        </div>
      </b-col>
    </b-row>

    <b-card no-body class="mb-0 table-card table-hover table-custom-striped">
      <b-table ref="refListTable" class="position-relative list-table" :items="fetchTableData" responsive
        :fields="tableColumns" primary-key="id" v-model:sort-by="sortBy" show-empty empty-text="No matching records found"
        v-model:sort-desc="isSortDirDesc">
        <template #cell(role_id)="data">
          <b-form-checkbox v-model="checkedAllBox" v-if="data.index + 1 == 1" name="checkall-checkbox-main"
            class="checkall" @change="checkAll($event, data)" />
          <b-form-checkbox v-model="checkedProducts" name="checkall-checkbox" :checked="true" :value="data.item.id"
            @change="checkRow()">
            {{ data.value }}
          </b-form-checkbox>
        </template>

        <template #cell(name)="data">
          <b-link :to="{ name: 'role-view', params: { id: data.item.id } }">
            <span>{{ data.item.name }}</span>
          </b-link>
        </template>

        <template #cell(status)="data">
          <b-form-checkbox :id="'status_' + data.item.id" class="status-switch status-custom-switch"
            :checked="data.item.status == 1 ? true : false" switch v-if="ability.can('read', 'roles_edit')"
            @change="statusChange(data)" />
          <b-form-checkbox :id="'status_' + data.item.id" class="status-switch status-custom-switch"
            v-if="!ability.can('read', 'roles_edit')" :checked="data.item.status == 1 ? true : false" switch
            :disabled="true" />
        </template>
        <template #cell(actions)="data">
          <b-link class="mr-1" :to="{ name: 'role-view', params: { id: data.item.id } }"
            v-if="ability.can('read', 'roles_view')">
            <IconEye />
          </b-link>
          <b-link class="mr-1" :to="{ name: 'role-edit', params: { id: data.item.id } }"
            v-if="ability.can('read', 'roles_edit')">
            <IconPencil />
          </b-link>
          <b-link v-if="ability.can('read', 'roles_delete')" class="mr-1" @click="deleteItem(data)">
            <IconTrash />
          </b-link>
        </template>
      </b-table>
    </b-card>
    <div class="mx-1 mb-2 mt-1">
      <b-row class="align-items-center">
        <b-col cols="12" sm="4" class="d-flex align-items-center justify-content-center justify-content-sm-start">
        </b-col>
        <b-col cols="12" sm="4" class="search-input-center search-bx d-flex justify-content-center">
          <b-row class="align-items-center mb-0 mt-0">
            <div>
              <span class="text-nowrap mr-1"> Show</span>
            </div>
            <div>
              <pagination-select-dropdown :options="perPageOptions" :selectedValue="perPage" @perPage="changePerPage" />
            </div>
            <div>
              <span class="text-nowrap ml-2">Showing {{ dataMeta.from }} - {{ dataMeta.to }} / {{ dataMeta.of }}</span>
            </div>
          </b-row>
        </b-col>
        <b-col cols="12" sm="4" class="d-flex align-items-center justify-content-center justify-content-sm-end">
          <b-pagination v-model="currentPage" :total-rows="totalData" :per-page="perPageValue" first-number last-number
            class="mb-0 mt-1 mt-sm-0" prev-class="prev-item" next-class="next-item">
            <template #prev-text>
              <FeatherIcon icon="ChevronLeftIcon" size="18" />
            </template>
            <template #next-text>
              <FeatherIcon icon="ChevronRightIcon" size="18" />
            </template>
          </b-pagination>
        </b-col>
      </b-row>
    </div>

    <!-- Delete Confirm Modal -->
    <b-modal ref="deleteConfirmModal" id="deleteConfirmModal" size="sm" hide-footer>
      <div class="mt-1 convert-model">
        <center>
          <IconWarning class="tick-icon align-center" />
          <h3>Are you sure</h3>
          <p>
            Are you sure you want to Delete {{ this.moduleLable }}
            <span class="text-primary">{{ this.itemLabel }}</span>?
          </p>
        </center>
        <center class="mt-2">
        
          <b-button class="btn-reset" variant="flat-secondary" type="button"
            @click="$bvModal.hide('deleteConfirmModal')">
            No, Go Back
          </b-button>
          <b-button class="btn-submit-edit" variant="primary" type="submit" @click="deleteRole">
            Yes, Delete
          </b-button>
        </center>
       </div>
    </b-modal>
    <!-- Status Confirm Modal -->
    <b-modal ref="statusConfirmModal" id="statusConfirmModal" size="sm" hide-footer @hidden="closeStatusModal">
      <div class="mt-1 convert-model">
        <center>
          <IconWarning class="tick-icon align-center" />
          <h3>{{ this.newStatusWant ? "Active" : "Inactive" }} {{ this.moduleLable }}</h3>
          <p>
            Are you sure you want to {{ this.newStatusWant ? "Active" : "Inactive" }}
            {{ this.moduleLable }} <span class="text-primary">{{ this.itemLabel }}</span>?
          </p>
        </center>
        <center class="mt-2">
       
          <b-button class="btn-reset" variant="flat-secondary" type="button"
            @click="$bvModal.hide('statusConfirmModal')">
            No, Go Back
          </b-button>
          <b-button class="btn-submit-edit" variant="primary" type="submit" @click="statusChangeConfirm">
            {{ this.newStatusWant ? "Yes, Active" : "Yes, Inactive" }}
          </b-button>
        </center>
       </div>
    </b-modal>
    <b-modal ref="filterModal" id="filterModal" size="md" hide-footer>
      <div class="list-filter-modal">
        <div class="d-flex list-filter-header mheader shadow">
          <div class="col p-0">
            <IconFilter></IconFilter>
          </div>
          <h4 class="title col text-center color-black mb-0">Filters</h4>
          <b-link class="col p-0 text-right" variant="primary" @click="resetFilter">
            Reset Filters
          </b-link>
        </div>

        <div class="pt-1">
            <b-form class="filter-form">
              <b-row>
                <b-col cols="12">
                  <b-form-group class="mb-2">
                    <label for="v-Status" class="d-block label-with-icon px-1">
                      <IconSearchLine></IconSearchLine> Select
                      Status</label>
                      <CustomSelectDropdown :options="searchStatus" :selectAll="true" :isAllChecked="isAllChecked"
                        :selectedItemsArr="filter.status" :selectTitle="'Status'" :title="'Status'" :filterButton="false"
                        @filterButtonAction="applyFilterAction"></CustomSelectDropdown>
                  </b-form-group>
                </b-col>
              </b-row>
            </b-form>
        </div>
        <div class="text-center filter-footer">
          <b-button size="lg" class="theme-btn" variant="primary" @click="applyFilter">
            Apply
          </b-button>
        </div>
      </div>
    </b-modal>
    <ExportColumn ref="mainExport" :searchQuery="searchQuery" :sortBy="sortBy" :isSortDirDesc="isSortDirDesc"
      :moduleColumn="moduleColumn" :module="'role'" :checkedProducts="checkedProducts" :checkedAllBox="checkedAllBox"
      :filter="filter"></ExportColumn>
  </div>
</template>
<script>
import {
  BCard,
  BRow,
  BCol,
  BFormInput,
  BButton,
  BTable,
  BMedia,
  BAvatar,
  BLink,
  BBadge,
  BDropdown,
  BDropdownItem,
  BFormGroup,
  BPagination,
  BFormCheckbox,
  BFormSelect,
  BForm,
  BImg,
  BModal
} from "bootstrap-vue";
import vSelect from "vue-select";
import store from "@/store";
import { ref, onUnmounted } from "vue";
import { avatarText } from "@core/utils/filter";
import userService from "./service";
import commonModule from "../common/module";
import ability from "@/libs/acl/ability";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import CustomSelectDropdown from "@/views/common/components/c-select-dropdown/CSelectDropdown.vue";
import ExportColumn from "@/views/common/components/c-select-dropdown/ExportColumn.vue";
import PaginationSelectDropdown from "@/views/common/components/c-select-dropdown/PaginationSelectDropdown.vue";
import { useToast } from "vue-toastification";
const toast = useToast();
export default {
  components: {
    BModal,
    BCard,
    BRow,
    BCol,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BFormGroup,
    BPagination,
    vSelect,
    BFormCheckbox,
    BFormSelect,
    BImg,
    BForm,
    CustomSelectDropdown,
    ExportColumn,
    PaginationSelectDropdown,
  },
  setup() {
    const MODULE_NAME = "role";

    // Register module
    if (!store.hasModule(MODULE_NAME)) store.registerModule(MODULE_NAME, userService);
    // UnRegister on leave
    onUnmounted(() => {
      // if (store.hasModule(MODULE_NAME)) store.unregisterModule(MODULE_NAME);
    });

    const {
      refListTable,
      fetchTableData,
      perPage,
      currentPage,
      totalData,
      allCount,
      perPageValue,
      dataMeta,
      perPageOptions,
      searchQuery,
      moduleColumn,
      filterData,
      sortBy,
      isSortDirDesc,
      refetchData,
      resolveUserStatusVariant,
      resolveUserStatusText,
    } = commonModule(MODULE_NAME, "", {}, "id", false);

    return {
      // Sidebar
      refListTable,
      fetchTableData,
      perPage,
      currentPage,
      totalData,
      allCount,
      perPageValue,
      dataMeta,
      perPageOptions,
      searchQuery,
      moduleColumn,
      filterData,
      sortBy,
      isSortDirDesc,
      refetchData,
      resolveUserStatusVariant,
      resolveUserStatusText,
    };
  },
  watch: {
    currentPage: function (oldVal, newVal) {
      this.isSelect = true;
      this.selectUnselectAll();
    },
  },
  data() {
    const tableColumns = [
      { label: "Role ID", key: "role_id", class: "has_checkbox", sortable: true },
      { key: "name", sortable: true },
      { key: "status", sortable: true },
      { key: "actions" },
    ];
    return {
      itemLabel: "",
      moduleLable: "Role",
      newStatusWant: "",
      itemIdForStatus: "",
      checkedProducts: [],
      itemIdForDelete: [],
      checkedCount: 0,
      tableColumns,
      ability,
      checkedAllBox: false,
      itemLabel: "",
      searchStatus: [
        {
          id: 1,
          name: "Active",
        },
        {
          id: 2,
          name: "Inactive",
        },
      ],
      filter: {
        status: [],
      },
      isAllChecked: false,
    };
  },
  methods: {
    changePerPage(value) {
      this.perPage = value;
      this.changeListData();
    },
    applyFilterAction(data) {
      this.filter.status = data.selectedItems.map((e) => e.id);
      if (this.filter.status.length == this.searchStatus.length) {
        this.isAllChecked = true;
      } else {
        this.isAllChecked = false;
      }
    },
    columnModalToggle() {
      this.$refs['mainExport'].$refs["columnModal"].toggle();
    },
    filterModalToggle() {
      this.$refs["filterModal"].toggle();
    },
    applyFilter() {
      this.filterData = { status: this.filter.status };
      this.$refs["filterModal"].hide();
      if (this.filter.status.length == this.searchStatus.length) {
        this.isAllChecked = true;
      } else {
        this.isAllChecked = false;
      }
      this.changeListData();
    },
    resetFilter() {
      this.filter.status = [];
      this.isAllChecked = false;
    },
    checkAll(event) {
      this.checkedProducts = [];
      this.checkedCount = 0;
      this.isSelect = false;
      if (event) {
        document
          .querySelectorAll("input[type='checkbox'][name='checkall-checkbox']")
          .forEach((chk, index) => {
            this.checkedProducts.push(chk.value);
            this.checkedCount = index + 1;
          });
        if (this.checkedCount == this.allCount) {
          this.isSelect = true;
        }
      }
    },
    changeListData() {
      this.isSelect = false;
      this.checkedAllBox = false;
      this.checkedProducts = [];
      this.checkedCount = 0;
    },
    checkRow() {
      this.checkedCount = this.checkedProducts.length;
      if (this.checkedProducts.length == this.allCount) {
        this.isSelect = true;
        this.checkedAllBox = true;
      } else {
        this.isSelect = false;
        this.checkedAllBox = false;
      }
    },
    selectUnselectAll() {
      if (this.isSelect) {
        this.checkedProducts = [];
        this.checkedCount = 0;
        this.isSelect = false;
        this.checkedAllBox = false;
      } else {
        this.checkedProducts = [];
        this.checkedCount = 0;
        document
          .querySelectorAll("input[type='checkbox'][name='checkall-checkbox']")
          .forEach((chk, index) => {
            this.checkedProducts.push(chk.value);
            this.checkedCount = index + 1;
          });
        this.checkedAllBox = true;
        this.isSelect = true;
      }
    },
    statusChange(data) {
      this.$refs["statusConfirmModal"].show();
      this.itemIdForStatus = data.item.id;
      this.itemLabel = data.item.name;
      if (data.item.status == 1) {
        this.newStatusWant = false;
      } else {
        this.newStatusWant = true;
      }
    },
    statusChangeConfirm() {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      let formData = new FormData();
      formData.append("id", this.itemIdForStatus);
      formData.append("status", this.newStatusWant);
      store
        .dispatch("role/status", formData)
        .then((response) => {
          const statusObj = document.getElementById("status_" + this.itemIdForStatus);
          statusObj.checked = this.newStatusWant;
          this.newStatusWant = "";
          this.itemIdForStatus = "";
          this.itemLabel = "";
          this.refetchData();
          if (response.data.status == true) {
            this.showToast(
              "success",
              "CheckCircleIcon",
              response.data.title,
              response.data.message
            );
          } else {
            if (response.data.errors) {
              this.$refs.addEditFormRules.setErrors(response.data.errors);
            } else {
              this.showToast(
                "danger",
                "AlertCircleIcon",
                response.data.title,
                response.data.message
              );
            }
          }
          this.$refs["statusConfirmModal"].hide();
          appLoading.style.display = "none";
        })
        .catch(() => {
          this.$refs["statusConfirmModal"].hide();
          appLoading.style.display = "none";
        });
    },
    closeStatusModal() {
      if (this.itemIdForStatus != "") {
        const statusObj = document.getElementById("status_" + this.itemIdForStatus);
        statusObj.checked = this.newStatusWant ? false : true;
      }
    },
    deleteItem(data) {
      this.itemIdForDelete = [data.item.id];
      this.itemLabel = data.item.name;
      this.$refs["deleteConfirmModal"].show();
    },
    deleteRole() {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      let reqObj = { id: this.itemIdForDelete };
      store
        .dispatch("role/delete", reqObj)
        .then((response) => {
          if (response.data.status == true) {
            this.itemIdForDelete = "";
            this.itemLabel = "";
            this.showToast(
              "success",
              "CheckCircleIcon",
              response.data.title,
              response.data.message
            );
            this.refetchData();
          } else {
            if (response.data.errors) {
              this.$refs.addEditFormRules.setErrors(response.data.errors);
            } else {
              this.showToast(
                "danger",
                "AlertCircleIcon",
                response.data.title,
                response.data.message
              );
            }
          }
          this.$refs["deleteConfirmModal"].hide();
          appLoading.style.display = "none";
        })
        .catch(() => {
          this.$refs["deleteConfirmModal"].hide();
          appLoading.style.display = "none";
        });
    },
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title: title,
          icon,
          text: message,
          variant,
        },
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}

</style>

<style lang="scss">
// @import "~@resources/scss/vue/libs/vue-select.scss";

</style>
